<?php

namespace Drupal\migrate_html_to_paragraphs\Plugin\migrate\html\process;

use Drupal\migrate\MigrateExecutableInterface;
use Drupal\paragraphs\Entity\Paragraph;

/**
 * Migration HTML - iframe processor.
 *
 * @MigrateHtmlProcessPlugin(
 *   id = "html_process_iframe"
 * )
 */
class IframeProcess extends HtmlTagProcess {

  /**
   * {@inheritdoc}
   */
  public function process(MigrateExecutableInterface $migrate_executable, array $tag) {
    $this->migrateExecutable = $migrate_executable;
    return TRUE;
  }

  /**
   * {@inheritdoc}
   */
  public function createParagraph($value) {
    $text_format = 'embed_codes';

    if (empty(check_markup($value, $text_format))) {
      return NULL;
    }

    $paragraph = Paragraph::create([
      'id' => NULL,
      'type' => 'embed',
      'field_embed_code' => [
        'value' => $value,
        'format' => $text_format,
      ],
    ]);
    $paragraph->save();

    return $paragraph;
  }

}
